; ---purpose---
; Verify that at least one member of a list
; has a given property. Return *T*, if a
; member with the given property exists and
; otherwise *F*.

; ---args---
; A - list
; P - predicate to test desired property

; ---keywords---
; ANY function, property, predicate

; ---see-also---
; EVERY, SOME, MEMBER, REMOVE, UNIQUE

; ---example---
; (ANY '((A B C) X (D E F)) ATOM)

; ---model---
; (DEFUN ANY (X P)
;	(COND ((NULL X) *F*)
;		((P (CAR X)) *T*)
;		(T (ANY (CDR X) P))))

; ---code---
(DEFUN ANY (X P)
	(LABEL ((_ANY (LAMBDA (X)
			(COND ((NULL X) *F*)
				((P (CAR X)) *T*)
				(T (_ANY (CDR X)))))))
		(_ANY X)))

