; ---purpose---
; Retrieve a binding from an association list.
; An association list is a list of pairs where
; the CAR part of each pair holds a key and
; the CDR part of the pair holds the value
; associated with the given key:
; -
; ((key1.value1) ... (keyN.valueN))

; ---args---
; X - key of value to be found
; A - association list

; ---keywords---
; ASSOC function, association lists, associate

; ---see-also---
; PAIR, SASSOC, SUBLIS

; ---example---
; (ASSOC '3 '((1.I) (2.II) (3.III) (4.IV)))

:C LIB/EQUAL.L
:C LIB/CAAR.L
;C LIB/CDAR.L

; ---model---
; (DEFUN ASSOC (X A)
;	(COND ((NULL A) NIL)
;		((EQUAL (CAAR A) X) (CAR A))
;		(T (ASSOC X (CDR A)))))

; ---code---
(DEFUN ASSOC (X A)
	(LABEL ((ASC (LAMBDA (A)
			(COND ((NULL A) NIL)
				((EQUAL (CAAR A) X) (CAR A))
				(T (ASC (CDR A)))))))
		(ASC A)))

