; ---purpose---
; Access elements of nested lists.

; ---args---
; X - list

; ---keywords---
; CAAAAR, CAAADR, CAADAR, CAADDR
; CAADAR, CADADR, CADDAR, CADDDR
; CDAAAR, CDAADR, CDADAR, CDADDR
; CDDAAR, CDDADR, CDDDAR, CDDDDR
; lists, selector, decomposition

; ---see-also---
; CAAAR, CAAR

; ---example---
; (CADDDR '(FIRST SECOND THIRD FOURTH FIFTH SIXTH SEVENTH EIGHTH))

; ---code---
(DEFUN CAAAAR (X) (CAR (CAR (CAR (CAR X)))))
(DEFUN CAAADR (X) (CAR (CAR (CAR (CDR X)))))
(DEFUN CAADAR (X) (CAR (CAR (CDR (CAR X)))))
(DEFUN CAADDR (X) (CAR (CAR (CDR (CDR X)))))
(DEFUN CADAAR (X) (CAR (CDR (CAR (CAR X)))))
(DEFUN CADADR (X) (CAR (CDR (CAR (CDR X)))))
(DEFUN CADDAR (X) (CAR (CDR (CDR (CAR X)))))
(DEFUN CADDDR (X) (CAR (CDR (CDR (CDR X)))))
(DEFUN CDAAAR (X) (CDR (CAR (CAR (CAR X)))))
(DEFUN CDAADR (X) (CDR (CAR (CAR (CDR X)))))
(DEFUN CDADAR (X) (CDR (CAR (CDR (CAR X)))))
(DEFUN CDADDR (X) (CDR (CAR (CDR (CDR X)))))
(DEFUN CDDAAR (X) (CDR (CDR (CAR (CAR X)))))
(DEFUN CDDADR (X) (CDR (CDR (CAR (CDR X)))))
(DEFUN CDDDAR (X) (CDR (CDR (CDR (CAR X)))))
(DEFUN CDDDDR (X) (CDR (CDR (CDR (CDR X)))))
