; ---purpose---
; Access elements of nested lists.

; ---args---
; X - list

; ---keywords---
; CAAAR, CAADR, CADAR, CADDR
; CDAAR, CDADR, CDDAR, CDDDR
; lists, selector, decomposition

; ---see-also---
; CAAAAR, CAAR

; ---example---
; (CADDR '(FIRST SECOND THIRD FOURTH FIFTH SIXTH SEVENTH EIGHTH))

; ---code---
(DEFUN CAAAR (X) (CAR (CAR (CAR X))))
(DEFUN CAADR (X) (CAR (CAR (CDR X))))
(DEFUN CADAR (X) (CAR (CDR (CAR X))))
(DEFUN CADDR (X) (CAR (CDR (CDR X))))
(DEFUN CDAAR (X) (CDR (CAR (CAR X))))
(DEFUN CDADR (X) (CDR (CAR (CDR X))))
(DEFUN CDDAR (X) (CDR (CDR (CAR X))))
(DEFUN CDDDR (X) (CDR (CDR (CDR X))))
