; ---purpose---
; Compare two lists (s-expressions, in fact).
; Return *T*, if both expressions print equal.

; ---args---
; A - expression
; B - expression

; ---keywords---
; EQUAL function, equivalence, relation, comparison, predicate

; ---see-also---
; NEQUAL, MEMBER, SUBST

; ---example---
; (EQUAL '(A B (C D (E)) F) '(A B (C D (E)) F))

:C LIB/LOGOR.L

; ---model---
; (DEFUN EQUAL (A B)
;	(COND ((LOGOR (ATOM A) (ATOM B)) (EQ A B))
;		((EQUAL (CAR A) (CAR B)) (EQUAL (CDR A) (CDR B)))
;		(T *F*)))

; ---code---
(DEFUN EQUAL (A B)
	(LABEL ((EQU (LAMBDA (A B CA CB)
 		(COND ((NULL A)
				(COND ((NULL B)
						(COND ((NULL CA) *T*)
							(T (EQU (CAR CA) (CAR CB) (CDR CA) (CDR CB)))))
					(T *F*)))
			((LOGOR (ATOM A) (ATOM B))
				(COND ((EQ A B) (EQU NIL NIL CA CB)) (T *F*)))
			(T (EQU (CAR A) (CAR B) (CONS (CDR A) CA)
				(CONS (CDR B) CB)))))))
	(EQU A B NIL NIL)))
