; ---purpose---
; Verify that all members of a list have
; a given property. Return *T*, if all
; members have the requested property and
; *F* if at least one member does not have
; the property.

; ---args---
; A - list
; P - predicate to test desired property

; ---keywords---
; EVERY function, property, predicate

; ---see-also---
; ANY, SOME, MEMBER, REMOVE, UNIQUE

; ---example---
; :L LIB/NUMBERP.L
; (EVERY '(#5 #7 #12) NUMBERP)

; ---model---
; (DEFUN EVERY (X P)
; 	(COND ((NULL X) *T*)
; 		((P (CAR X)) (EVERY (CDR X) P))
; 		(T *F*)))

; ---code---
(DEFUN EVERY (X P)
	(LABEL ((EVR (LAMBDA (X)
			(COND ((NULL X) *T*)
				((P (CAR X)) (EVR (CDR X)))
				(T *F*)))))
		(EVR X)))
