; ---purpose---
; Extract members matching a given predicate from a list.

; ---args---
; A - list
; P - predicate to match

; ---keywords---
; FILTER function, lists, filtering

; ---see-also---
; REMOVE

; ---example---
; :L LIB/NUMBERP.L
; (FILTER '(ABC #123 DEF #456 GHI) NUMBERP)

:C LIB/REVERSE.L

; ---model---
; (DEFUN FILTER (A P)
;	(COND ((NULL A) NIL)
;		((P (CAR A)) (CONS (CAR A) (FLT (CDR A) P)))
;			(T (FLT (CDR A) P))))

; ---code---
(DEFUN FILTER (A P)
	(LABEL ((FLT (LAMBDA (A B)
			(COND ((NULL A) B)
				((P (CAR A)) (FLT (CDR A) (CONS (CAR A) B)))
				(T (FLT (CDR A) B))))))
		(FLT (REVERSE A) NIL)))
