; ---purpose---
; Compute the greatest common divisor (GCD) using
; Euclid's Algorithm.

; ---args---
; A - list of digits
; B - list of digits

; ---keywords---
; IGCD function, gcd, greatest common divisor
; Euclid, Euclid's algorithm, arithmetics, integer

; ---see-also---
; DIGITS, EXPT, FAC, IEXPT, PRODUCT, SUM

; ---example---
; (GCD '#99 '#-77)

(DEFINE GCD T)

:C LIB/ABS.L
:C LIB/NATURAL.L
:C LIB/ZEROP.L
:C LIB/REMAINDER.L
:C LIB/LESSP.L

; ---code---
(DEFUN GCD (A B)
	(LABEL ((_GCD (LAMBDA (A B)
			(COND ((ZEROP B) A)
				((LESSP A B) (_GCD A (REMAINDER B A)))
				(T (_GCD B (REMAINDER A B)))))))
		(_GCD (NATURAL (ABS A)) (NATURAL (ABS B)))))

