; ---purpose---
; Divide two decimal integer numbers, giving a
; result of the form (quotient remainder).
; Numbers are represented by lists of digits.

; ---args---
; A - list of digits (dividend)
; B - list of digits (divisor)

; ---keywords---
; IDIVIDE function, quotient, modulus, division, divide
; arithmetics, integer

; ---see-also---
; DIGITS, DIVIDE, IQUOTIENT, IREMAINDER, IPLUS, IDIFFERENCE
; ITIMES, MINUS

; ---example---
; (IDIVIDE '#11 '#-2)

(DEFINE IDIVIDE T)

:C LIB/DIGITS.L
:C LIB/LESSP.L
:C LIB/ZEROP.L
:C LIB/CAAR.L
;C LIB/CADR.L
:C LIB/DIVIDE.L
:C LIB/INTEGER.L

; ---code---
(DEFUN IDIVIDE (A B)
	(LABEL

	((SIGN (COND ((EQ (CAR A) (CAR B)) '+) (T '-)))

	(IDIV (LAMBDA (A B)
		(COND ((ZEROP B) (BOTTOM 'IDIVIDE))
			; overflow?
			((LESSP (CDR A) (CDR B)) (LIST '#+0 (CONS SIGN (CDR A))))
			; compute quotient, remainder
			(T (LABEL ((Q (DIVIDE (CDR A) (CDR B))))
				(LIST (CONS SIGN (CAR Q))
						(CONS SIGN (CADR Q)))))))))

	(IDIV (INTEGER A) (INTEGER B))))
