; ---purpose---
; Find the maximum of a set/list. Integer version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; IMAX function, maximum, comparison, arithmetics, integer

; ---see-also---
; DIGITS, MAX, IGREATERP, IMIN

; ---example---
; (IMAX '(#-25 #5 #25 #0 #-5))

:C LIB/CAAR.L
;C LIB/CADR.L
;C LIB/CDDR.L
:C LIB/IGREATERP.L

; ---code---
(DEFUN IMAX (A)
	(COND ((NULL (CDR A)) (CAR A))
		((IGREATERP (CAR A) (CADR A))
			(IMAX (CONS (CAR A) (CDDR A))))
		(T (IMAX (CDR A)))))
