; ---purpose---
; Find the minimum of a set/list. Integer version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; IMIN function, minimum, comparison, arithmetics, integer

; ---see-also---
; DIGITS, MIN, ILESSP, IMAX

; ---example---
; (IMIN '(#-25 #5 #25 #0 #-5))

:C LIB/CAAR.L
;C LIB/CADR.L
;C LIB/CDDR.L
:C LIB/ILESSP.L

; ---code---
(DEFUN IMIN (A)
	(COND ((NULL (CDR A)) (CAR A))
		((ILESSP (CAR A) (CADR A))
			(IMIN (CONS (CAR A) (CDDR A))))
		(T (IMIN (CDR A)))))
