; ---purpose---
; Generate a sequence of natural numbers.

; ---args---
; N - maximum number in sequence.

; ---keywords---
; IOTA function, sequence of numbers, arithmetics, natural

; ---see-also---
; DIGITS, SUM, PRODUCT

; ---example---
; (IOTA '#10)

:C LIB/DIGITS.L
:C LIB/APPEND.L
:C LIB/NATURAL.L
:C LIB/DECR.L
:C LIB/ZEROP.L

; ---model---
; (DEFUN IOTA(X)
; 	(COND ((ZEROP X) NIL)
; 		(T (APPEND (IOTA (DECR X)) (LIST X)))))

; ---code---
(DEFUN IOTA(X)
	(LABEL ((J (LAMBDA (X R)
			(COND ((ZEROP X) R)
				(T (J (DECR X) (CONS X R)))))))
		(J (NATURAL X) NIL)))

