; ---purpose---
; Add two decimal integer numbers. Numbers are
; represented by lists of digits.

; ---args---
; A - list of digits
; B - list of digits

; ---keywords---
; IPLUS function, plus, sum, addition, arithmetics, integer

; ---see-also---
; DIGITS, PLUS, IDIFFERENCE, IDIVIDE, IQUOTIENT, IREMAINDER
; ITIMES, MINUS

; ---example---
; (IPLUS '#-55 '#-77)

(DEFINE IPLUS T)

:C LIB/DIGITS.L
:C LIB/ABS.L
:C LIB/MINUS.L
:C LIB/GREATERP.L
:C LIB/LOGAND.L
:C LIB/IDIFFERENCE.L
:C LIB/PLUS.L
:C LIB/INTEGER.L

; ---code---
(DEFUN IPLUS (A B)
	(LABEL ((_IPLUS (LAMBDA (A B)
		; A>=0, B>=0: A+B => |A|+|B|
		(COND ((LOGAND (EQ (CAR A) '+) (EQ (CAR B) '+))
				(CONS '+ (PLUS (CDR A) (CDR B))))
			; A>=0, B<0
			((LOGAND (EQ (CAR A) '+) (EQ (CAR B) '-))
				; |A|>|B| => A-|B|
				(COND ((GREATERP (CDR A) (CDR B)) (IDIFFERENCE A (ABS B)))
					; |A|<=|B| => -(|B|-A)
					(T (MINUS (IDIFFERENCE (ABS B) A)))))
			; A<0, B>=0
			((LOGAND (EQ (CAR A) '-) (EQ (CAR B) '+))
				; |A|>|B| => -(|A|-B)
				(COND ((GREATERP (CDR A) (CDR B))
						(MINUS (IDIFFERENCE (ABS A) B)))
					; |A|<=|B| => B-|A|
					(T (IDIFFERENCE B (ABS A)))))
			; A<0, B<0 => -(|A|+|B|)
			(T (CONS '- (PLUS (CDR A) (CDR B))))))))

	(_IPLUS (INTEGER A) (INTEGER B))))
