; ---purpose---
; Check if an expression is a (proper) list.
; Proper lists are:
; -
; NIL, cons[X;NIL], cons[Y;cons[X;NIL]], etc.

; ---args---
; X - expression

; ---keywords---
; LISTP function, atom, non-atom, list, pair

; ---see-also---
; PAIRP

; ---example---
; (LISTP '(A B C))

; ---model---
; (DEFUN LISTP (X)
;	(COND ((NULL X) *T*)
;		((ATOM X) *F*)
;		(T (LISTP (CDR X)))))

; ---code---
; THIS FUNCTION WILL FAIL TO DETECT IMPROPER LISTS
; [LISTS OF THE FORM (X ... Y.Z)]. HOWEVER, IMPROPER LISTS
; ARE NOT DEFINED IN ARROW LISP, ANYWAY.
(DEFUN LISTP (X)
	(COND ((NULL X) *T*)
		((ATOM X) *F*)
		((NULL (CDR X)) *T*)
		((ATOM (CDR X)) *F*)
		(T T)))
