; ---purpose---
; Apply a function to each member of a list.

; ---args---
; A - list
; F - function to apply to each member

; ---keywords---
; MAPCAR function, mapping, lists, CAR

; ---see-also---
; MAP, MAPLIS, REDUCE

; ---example---
; :L LIB/MINUS.L
; (MAPCAR '(#1 #2 #3) MINUS)

:C LIB/REVERSE.L

; ---model---
; (DEFUN MAPCAR (A F)
;	(COND ((NULL T) B)
;		(T (CONS (F (CAR A)) (MAPCAR (CDR A) F)))))

; ---code---
(DEFUN MAPCAR (A F)
	(LABEL ((MAPC (LAMBDA (A B)
		(COND ((NULL A) B)
			(T (MAPC (CDR A) (CONS (F (CAR A)) B)))))))
	(MAPC (REVERSE A) NIL)))
