; ---purpose---
; Check if any member of a list is identical
; to a given symbol.

; ---args---
; X - symbol to find
; A - list

; ---keywords---
; MEMB function, member of, sets, set theory

; ---see-also---
; UNION, INTERSECTION, UNIQUE

; ---example---
; (MEMB 'C '(A B C D E F))

; ---model---
; (DEFUN MEMB (X A)
; 	(COND ((NULL A) *F*)
; 		((EQ (CAR A) X) T)
; 		(T (MEMB X (CDR A)))))

; ---code---
(DEFUN MEMB (X A)
	(LABEL ((MMB (LAMBDA (A)
			(COND ((NULL A) *F*)
				((EQ (CAR A) X) T)
				(T (MMB (CDR A)))))))
		(MMB A)))
