; ---purpose---
; Test if a number is a natural number.
; A natural number is a number without a sign.
; -
; Hence (NATURALP '#+1) => *F*.

; ---args---
; A - list of digits with optional sign

; ---keywords---
; NATURALP function, numeric, numbers, digits, predicate, natural

; ---see-also---
; DIGITS, NATURAL, INTEGER, NUMBERP, ZEROP, MINUSP

; ---example---
; (NATURALP '#-567)

:C LIB/DIGITS.L

; ---code---
(DEFUN NATURALP(A)
	(COND ((EQ (CAR A) '+) *F*)
		((EQ (CAR A) '-) *F*)
		(T *T*)))
