; ---purpose---
; Extract the tail beginning at the n'th member of
; a list X. The first element has the position '#1.
; Retrieving the '#0'th element of X results in
; cons[NIL;X].

; ---args---
; X - list
; N - position of member to extract

; ---keywords---
; NTH function, list, n'th member, position

; ---see-also---
; CAAR, CAAAR, CAAAAR, LAST

; ---example---
; (NTH '(A B C D E F) '#3)

:C LIB/ONEP.L
:C LIB/ZEROP.L
:C LIB/DECR.L

; ---code---
(DEFUN NTH (X N)
	(COND ((NULL X) NIL)
		((ZEROP N) (CONS NIL X))
		((ONEP N) X)
		(T (NTH (CDR X) (DECR N)))))
