; ---purpose---
; Check if the members of a list
; are in a given monotonic order.

; ---args---
; X - list
; P - predicate defining order

; ---keywords---
; ORDEREDP function, ordered, ordering, relation
; lists, predicate

; ---see-also---
; INSERT, SORT

; ---example---
; :L LIB/GREATERP.L
; (ORDEREDP '(#9 #8 #7 #6 #5) GREATERP)

:C LIB/CAAR.L
;C LIB/CADR.L

; ---model---
; (DEFUN ORDEREDP (X P)
; 	(COND ((NULL X) *T*)
; 		((NULL (CDR X)) *T*)
; 		((P (CAR X) (CADR X)) (ORDEREDP (CDR X) P))
; 		(T *F*)))

; ---code---
(DEFUN ORDEREDP (X P)
	(LABEL ((ODP (LAMBDA (X)
			(COND ((NULL X) *T*)
				((NULL (CDR X)) *T*)
				((P (CAR X) (CADR X)) (ODP (CDR X)))
				(T *F*)))))
		(ODP X)))
