; ---purpose---
; Build an association list from two lists.

; ---args---
; X - list containing car parts
; Y - list containing cdr parts

; ---keywords---
; PAIR function, assocation lists, associate

; ---see-also---
; ASSOC, SASSOC

; ---example---
; (PAIR '(1 2 3) '(I II III))

;C LIB/REVERSE.L
:C LIB/MAP.L

; ---model---
; (DEFUN PAIR (X Y)
;	(COND ((NULL X) NIL)
;		((NULL Y) NIL)
;		(T (CONS (CONS (CAR X) (CAR Y)) (PAIR (CDR X) (CDR Y))))))

; ---model---
; ; TAIL-RECURSIVE VERSION
; (DEFUN PAIR (X Y)
;	(LABEL ((PAR (LAMBDA (X Y R)
;		(COND ((NULL X) R)
;			((NULL Y) R)
;			(T (PAR (CDR X) (CDR Y) (CONS (CONS (CAR X) (CAR Y)) R)))))))
;	(REVERSE (PAR X Y NIL))))

; ---code---
(DEFUN PAIR (A B) (MAP A B CONS))
