; ---purpose---
; Compute the product of a sequence of
; positive numbers. Number are represented by
; lists of digits.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; PRODUCT function, product of sequence

; ---see-also---
; DIGITS, EXPT, FAC, GCD, SUM

; ---example---
; (PRODUCT '#5 '#7)

(DEFINE PRODUCT T)

:C LIB/DIGITS.L
:C LIB/EQUAL.L
:C LIB/GREATERP.L
:C LIB/TIMES.L
:C LIB/INCR.L
:C LIB/NATURAL.L

; ---model---
; (DEFUN PRODUCT(N M)
;	(COND ((EQUAL N M) M)
;			(T (TIMES N (PRODUCT (INCR N) M)))))

; ---code---
(DEFUN PRODUCT(N M)
	(LABEL ((NN (NATURAL N)) (LIM (NATURAL M))
		(PROD (LAMBDA (N R)
			(COND ((GREATERP N LIM) R)
				(T (PROD (INCR N) (TIMES N R)))))))
		(COND ((GREATERP NN LIM) (BOTTOM 'PRODUCT:RANGE))
			(T (PROD NN '#1)))))
