; ---purpose---
; Reduce a list. Combine the first member of the
; list with the reduced rest of the list using a
; given function.

; ---args---
; A - list to reduce
; X - default member (replaces NIL)
; F - combining function

; ---keywords---
; REDUCE function, reduction, reduce lists

; ---see-also---
; MAP, MAPCAR, MAPLIS

; ---example---
; :L LIB/PLUS.L
; (REDUCE '(#1 #2 #3 #4) '#5 PLUS)

:C LIB/REVERSE.L

; ---model---
; (DEFUN REDUCE (A X F)
;	(COND ((NULL A) X)
;		(T (F (CAR A) (REDUCE (CDR A) X F)))))

; ---code---
(DEFUN REDUCE (A X F)
	(LABEL ((RED (LAMBDA (A B)
			(COND ((NULL A) B)
				((NULL B) (RED (CDR A) (F (CAR A) X)))
				(T (RED (CDR A) (F (CAR A) B)))))))
		(RED (REVERSE A) NIL)))
