; ---purpose---
; Check if an expression X is the tail of an
; expression Y.

; ---args---
; X - possible tail
; Y - expression

; ---keywords---
; TAILP function, list, pair, tail

; ---see-also---
; HEADP, CAAR, CAAAR, CAAAAR, LISTP

; ---example---
; (TAILP '(D E F) '(A B C D E F))

:C LIB/EQUAL.L

; ---model---
; (DEFUN TAILP (X Y)
;	(COND ((NULL Y) (NULL X))
;		((EQUAL X Y) *T*)
;		(T (TAILP X (CDR Y)))))

; ---code---
(DEFUN TAILP (X Y)
	(LABEL ((TLP (LAMBDA (Y)
			(COND ((NULL Y) (NULL X))
				((EQUAL X Y) *T*)
				(T (TLP (CDR Y)))))))
		(TLP Y)))
