; ---purpose---
; Flatten a binary tree. Convert a binary tree to
; a flat list using depth first traversal.

; ---args---
; X - tree

; ---keywords---
; TREE-FLATTEN function, trees, flattening, lists

; ---see-also---
; TREE-INSERT, TREE-SORT, TREE-ASSOC

; ---example---
; (TREE-FLATTEN (LIST (LIST NIL '#5 NIL) '#7 (LIST NIL '#9 NIL)))

:C LIB/CAAAR.L
;C LIB/CADAR.L
:C LIB/CAAAAR.L
;C LIB/CADDAR.L
:C LIB/REVERSE.L

; ---code---
(DEFUN TREE-FLATTEN (X)
	(LABEL ((FLATTEN (LAMBDA (X R S)
			(COND ((NULL X)
					(COND ((NULL S) (REVERSE R))
						(T (FLATTEN (CADDAR S) (CONS (CADAR S) R)
							(CDR S)))))
				(T
					(FLATTEN (CAR X) R (CONS X S)))))))
		(FLATTEN X NIL NIL)))

