; ---purpose---
; Insert a node into an ordered tree.

; ---args---
; X - value of node to insert
; TREE - tree
; P - predicate of desired order

; ---keywords---
; TREE-INSERT function, sorting, tree sort, ordering
; trees, ordered trees

; ---see-also---
; TREE-SORT, TREE-FLATTEN, TREE-ASSOC, INSERT

; ---example---
; :L LIB/LESSP.L
; (TREE-INSERT '#5 (LIST NIL '#7 NIL) LESSP)

:C LIB/CAAR.L
;C LIB/CADR.L
:C LIB/CAAAR.L
;C LIB/CADDR.L

; ---model---
; (DEFUN TREE-INSERT (X TREE P)
;	(COND ((NULL TREE) (LIST NIL X NIL))
;		((P X (CADR TREE))
;			(LIST (TREE-INSERT X (CAR TREE) P)
;				(CADR TREE) (CADDR TREE)))
;		(T
;			(LIST (CAR TREE) (CADR TREE)
;				(TREE-INSERT X (CADDR TREE) P)))))

; ---code---
(DEFUN TREE-INSERT (X TREE P)
	(LABEL ((T-INS (LAMBDA (TREE)
			(COND ((NULL TREE) (LIST NIL X NIL))
				((P X (CADR TREE))
					(LIST (T-INS (CAR TREE))
						(CADR TREE) (CADDR TREE)))
				(T
					(LIST (CAR TREE) (CADR TREE)
						(T-INS (CADDR TREE))))))))
		(T-INS TREE)))

