; ---purpose---
; Sort a list using the bubblesort algorithm.

; ---args---
; X - list to sort
; P - predicate defining the desired order

; ---keywords---
; BUBBLESORT function, bubble sort, sorting, example

; ---example---
; :L LIB/LESSP.L
; (BUBBLESORT '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) LESSP)

:L LIB/CAAR.L
;L LIB/CADR.L
;L LIB/CDDR.L
:L LIB/ORDEREDP.L

; ---model---
(DEFUN BUBBLESORT (X P)
	(LABEL ((BUBBLE-UP (LAMBDA (X)
			(COND ((NULL X) NIL)
				((NULL (CDR X)) X)
				((P (CAR X) (CADR X))
					(CONS (CAR X) (BUBBLE-UP (CDR X))))
				(T (CONS (CADR X) (BUBBLE-UP (CONS (CAR X) (CDDR X))))))))
		(BUBBLE-STEP (LAMBDA (X)
			(COND ((ORDEREDP X P) X)
				(T (BUBBLE-STEP (BUBBLE-UP X)))))))
		(BUBBLE-STEP X)))
